/* Dalsi priklady na dvojrozmerne pole */
/* Prohledani diagonaly hlavni nebo vedlejsi - 2 zpusoby */
/* Prohledani oblasti matice - 2 zpusoby */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define VEL 5   /* VEL - konstanta urcujici velikost pole */

int main()
{
 int A[VEL][VEL];
 int i,j,pocet;

 srand( (unsigned)time( NULL ) ); /* inicializace generatoru
                                     nahodnych cisel syst. casem */
 /* naplneni matice nahodnymi cisly */
 for (i=0;i<VEL;i++)
   for (j=0;j<VEL;j++)
     A[i][j]=(50*rand())/RAND_MAX;

 /* vypise obsah pole */
 printf("Pole A\n");
 for (i=0;i<VEL;i++)
   {
    for (j=0;j<VEL;j++)  printf("%5d", A[i][j]);
    putchar('\n');
   }

 /* pocet cisel vetsich nez 10 na hlavni diagonale */
 pocet=0;
 for (i=0;i<VEL;i++)
    if (A[i][i]>10)
       pocet++;
 printf("\nPocet cisel na hlavni diagonale >10 je %d.\n", pocet);

 /* totez jinak, mene optimalni kod */
 pocet=0;
 for (i=0;i<VEL;i++)
    for (j=0;j<VEL;j++)
      if ((A[i][j]>10)&&(i==j))
         pocet++;
 printf("Pocet cisel na hlavni diagonale >10 je %d.\n", pocet);

 /* pocet cisel vetsich nez 10 na vedlejsi diagonale */
 pocet=0;
 for (i=0;i<VEL;i++)
    if (A[i][VEL-1-i]>10)
       pocet++;
 printf("Pocet cisel na vedlejsi diagonale >10 je %d.\n", pocet);

 /* totez jinak, mene optimalni kod */
 pocet=0;
 for (i=0;i<VEL;i++)
    for (j=0;j<VEL;j++)
      if ((A[i][j]>10)&&(i+j==VEL-1))
         pocet++;
 printf("Pocet cisel na vedlejsi diagonale >10 je %d.\n", pocet);


 /* pocet cisel pod vedlejsi diagonalou >10 */
 pocet=0;
 for (i=1;i<VEL;i++)
   for (j=VEL-i;j<VEL;j++)
     if (A[i][j]>10)
        pocet++;
 printf("Pocet cisel pod vedlejsi diagonalou >10 je %d.\n", pocet);

 /* totez jinak, mene optimalni kod */
 pocet=0;
 for (i=0;i<VEL;i++)
   for (j=0;j<VEL;j++)
     if ((A[i][j]>10)&&(i+j>=VEL))
        pocet++;
 printf("Pocet cisel pod vedlejsi diagonalou >10 je %d.\n", pocet);

 /* pocet cisel pod hlavni diagonalou >10 */
 pocet=0;
 for (i=1;i<VEL;i++)
   for (j=0;j<i;j++)
     if (A[i][j]>10)
        pocet++;
 printf("Pocet cisel pod hlavni diagonalou >10 je %d.\n", pocet);

 /* totez jinak, mene optimalni kod */
 pocet=0;
 for (i=0;i<VEL;i++)
   for (j=0;j<VEL;j++)
     if ((A[i][j]>10)&&(i>j))
        pocet++;
 printf("Pocet cisel pod hlavni diagonalou >10 je %d.\n", pocet);


 getchar();
 return 0;
}
