/* reseni soustavy lin. alg. rovnic Gaussovou eliminacni metodou */
/* zadani rovnice v souboru                                      */


#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define MAX 10  /* Maximalni rad soustavy rovnic */

int main()
{
 int rad;
 double A[MAX][MAX];
 double B[MAX];
 double pom;
 int i,j,k;
 FILE *fr;

 /* nacteni soustavy rovnic ze souboru */
 fr=fopen("DPOLE5.TXT", "r");
 if (fr==NULL) return 0;
 fscanf(fr, "%d", &rad);
 if ((rad<2)||(rad>MAX)) {fclose(fr); return 0;}

 for (i=0;i<rad;i++)
   {
    for (j=0;j<rad;j++) fscanf(fr, "%lf", &A[i][j]);
    fscanf(fr, "%lf", &B[i]);
   }
 fclose(fr);

 /* vypise obsah poli A a B */
 printf("\nZadana soustava rovnic\n");
 for (i=0;i<rad;i++)
   {
    for (j=0;j<rad;j++)  printf("%+7.3f*%c  ", A[i][j],('Z'-rad+1+j));
    printf("=%+7.3f\n", B[i]);
   }

 /* primy beh */               /* k - krok primeho behu */
 for (k=1;k<rad;k++)           /* i - cislo radku, j cislo sloupce */
   for (i=k;i<rad;i++)
     {
      pom=A[i][k-1]/A[k-1][k-1];
      for (j=k-1;j<rad;j++)
	A[i][j]=A[i][j]-pom*A[k-1][j];
      B[i]=B[i]-pom*B[k-1];
     }

 /* vypise obsah poli A a B */
 printf("Soustava rovnic po primem behu\n");
 for (i=0;i<rad;i++)
   {
    for (j=0;j<rad;j++)  printf("%+7.3f*%c  ", A[i][j],('Z'-rad+1+j));
    printf("=%+7.3f\n", B[i]);
   }


 /* zpetny beh */
 for (k=rad-2;k>=0;k--)
   for (i=k;i>=0;i--)
     {
      pom=A[i][k+1]/A[k+1][k+1];
      for (j=k;j<rad;j++)
	A[i][j]=A[i][j]-pom*A[k+1][j];
      B[i]=B[i]-pom*B[k+1];
     }

 /* vypise obsah poli A a B */
 printf("Soustava rovnic po zpetnem behu\n");
 for (i=0;i<rad;i++)
   {
    for (j=0;j<rad;j++)  printf("%+7.3f*%c  ", A[i][j],('Z'-rad+1+j));
    printf("=%+7.3f\n", B[i]);
   }

 /* konecna uprava */
 for (i=0;i<rad;i++) B[i]=B[i]/A[i][i];

 /* vypise reseni soustavy rovnic */
 printf("Reseni\n");
 for (i=0;i<rad;i++)
   printf("%c=%+7.3f  ", 'Z'-rad+1+i, B[i]);
 printf("\n");

 getchar();
}
