#include <stdio.h>
#include <stdlib.h>
#include <time.h>

/* Zakladni operace
   - vypis
   - soucet prvku
   - minimum a maximum
   -reseno pomoci uzivatelskych funkci
*/

#define VEL 20   /* VEL - konstanta urcujici velikost pole */

void InitGen()
{
 srand( (unsigned)time( NULL ) ); /* inicializace generatoru
                                     nahodnych cisel syst. casem                                    */
}

void VypisPoleInt(int A[], int velikost, int naRadek)
{
 int i;
 for (i=0;i<velikost;i++)
   {
    printf("%7d", A[i]);
    if (((i+1)%naRadek==0)||(i+1)==velikost) putchar('\n');
   }
}

void NaplnNahodne(int A[], int velikost)
{
 int i;
 for (i=0;i<velikost;i++)
     A[i]=rand()-RAND_MAX/2;
}

int SoucetPole(int A[], int velikost)
{
    int i;
    int soucet=0;
    for (i=0;i<velikost;i++)
        soucet=soucet+A[i];
    return soucet;
}

void PrevratPoleInt(int A[], int velikost)
{
    int i;
    int pom;
    for (i=0;i<velikost/2;i++)
        {
          pom=A[i];
          A[i]=A[velikost-1-i];
          A[VEL-1-i]=pom;
        }
}

int MaximumP(int A[], int velikost)
{
    int i;
    int imax=A[0];
    for (i=1;i<velikost;i++)
        if (A[i]>imax) imax=A[i];
    return imax;
}

int MinimumP(int A[], int velikost)
{
    int i;
    int imin=A[0];
    for (i=1;i<velikost;i++)
        if (A[i]<imin) imin=A[i];
    return imin;
}

int PoziceMaxima(int A[], int velikost)
{
    int i;
    int nmax=0;
    for (i=1;i<velikost;i++)
        if (A[i]>A[nmax]) nmax=i;;
    return nmax;
}

int PoziceMinima(int A[], int velikost)
{
    int i;
    int nmin=0;
    for (i=1;i<velikost;i++)
        if (A[i]<A[nmin]) nmin=i;;
    return nmin;
}

int main()
{
 int pole1[VEL];

 printf("\nVelikost pole je %d bajtu a %d polozek\n", sizeof(pole1),
	    sizeof(pole1)/sizeof(int));

/* naplneni pole nahodnymi cisly */
 InitGen();
 NaplnNahodne(pole1, VEL);
/* vypise obsah pole, 5 cisel na radku */
 VypisPoleInt(pole1, VEL, 5);

 /* vypocita soucet prvku pole a vypise jej na obrazovku */
 printf("Soucet prvku pole je %ld.\n", SoucetPole(pole1, VEL));
 /* jine soucty */
 printf("Soucet prvnich 5 prvku pole je %ld.\n", SoucetPole(pole1, 5));
 printf("Soucet prvku pole 11..14 je %ld.\n", SoucetPole(pole1+11, 4));

 /* prevrati poradi prvku v poli */
 PrevratPoleInt(pole1, VEL);
 /* vypise znovu obsah pole, 6 cisel na radku */
 VypisPoleInt(pole1, VEL, 6);

 /* nalezne maximum a minimum cislo a vypise je obrazovku */
 printf("Maximalni cislo je %d.\n", MaximumP(pole1, VEL));
 printf("Minimalni cislo je %d.\n", MinimumP(pole1, VEL));
 /* nalezne maximum a minimum cislo vcetne jeho pozice */
 printf("Maximalni cislo je %d na pozici %d.\n", pole1[PoziceMaxima(pole1, VEL)], PoziceMaxima(pole1, VEL));
 printf("Minimalni cislo je %d na pozici %d.\n", pole1[PoziceMinima(pole1, VEL)], PoziceMinima(pole1, VEL));

 getchar();
}
