/* priklad 1 na dynamicke dvourozmerne pole */
/* Nejdrive je alokovano jednorozmerne pole ukazatelu
   Prvky tohoto pole ukazuji na jednorozmerna pole ... radky matice
   Ve druhem kroku se musi alokovat pamet pro tyto radky matice.
   Obecne by mohly radky byt ruzne dlouhe, v tomto prikladu jsou vsechny
   stejne */
/* V prikladu je navic ukazano osetrene nacitani cisel z klavesnice
   a vypocet souctu prvku na vedlejsi diagonale matice */

/* Navic vypsany adresy prvku matice, je zrejme, ze prvky v radku
   jsou v pameti souvisle, ale radky v pameti souvisle nejsou */

#include <stdio.h>
#include <stdlib.h>

typedef int *radek;   // novy datovy typ - 1radek matice

void testmem(void *uk)	// funkce testuje ukazatel - pouzito na testovani prideleni pameti
{
 if (uk==NULL)
  {
   printf("\nNeni dost pameti, koncim!\n");
   exit(10);
  }
}

int NactiPrvek(int x, int y)
{
int cislo,i,j;
do {
    if (x>=0)
      printf("\nZadej prvek mat[%d,%d]: ", x, y);
     else
      printf("\nZadej rozmer ctvercove matice: ");

    i=scanf("%i",&cislo);
    j=getchar();
    if ((i!=0) && ((j!='\n') && (j!=' ') && (j!='\t'))) i=0;
    if (i==0) printf("Chyba !!!\n");
    if (j!='\n') while (getchar()!='\n');

    } while (i==0);
return cislo;
}


int main()
{
 int i, j;
 int max;
 radek *mat;	// promenna mat je typu ukazatel na radek matice, tj. ukazatel na ukazatel na cislo,
                // tj. dvojrozmerne pole
 int suma;

 max=NactiPrvek(-1,0); /* Nacte rozmer matice */
 mat=(radek *)malloc(max*sizeof(radek)); /* alokace pole ukazatelu na radky matice */
 testmem(mat);
 for (i=0;i<max;i++)	// alokace pameti na jednotlive radky matice
  {
   mat[i]=(radek)malloc(max*sizeof(int));
   testmem(mat[i]);
  }
 printf("Alokace matice OK!\n");
 for (i=0;i<max;i++)				// nacteni prvku matice
   for (j=0;j<max;j++)				// pouzita funkce NactiPrvek
     mat[i][j]=NactiPrvek(i, j);	// s vlastni dvojrozmernou matici lze pracovat beznym zpusobem
									// pomoci hranatych zavorek
 printf("\nByla nactena matice");
 for (i=0;i<max;i++)	// vypise obsah matice
   {
    printf("\n");
    for (j=0;j<max;j++) printf("%8d", mat[i][j]);
   }

 printf("\nAdresy prvku matice:");	// vypise adresy prvku matice
 for (i=0;i<max;i++)
   {
    printf("\n");
    for (j=0;j<max;j++) printf("    %p", &mat[i][j]);
   }


 suma=0;
 for (i=0;i<max;i++)
	 suma+=mat[i][max-1-i];		// dalsi ukony s matici lze provadet beznym zpusobem
 printf("\n\nSoucet cisel na vedlejsi diagonale je: %d\n", suma);
 getchar();
 return 0;
}

