#include <stdio.h>
#include "matem.h"

int errx; /* priklad pouziti globalni promenne */

double msin(double x)
{
 double y, Q;
 int i;

 while (x>PI2) x-=PI2;
 while (x<0) x+=PI2;

 y=x;
 Q=x;
 for (i=1;Q>EPS;i++) {
   Q=Q*x*x/(2*i)/(2*i+1);
   y+=Q*(1-2*(i%2));
   }
 return y;
}

double msqrt(double X)
{
 double x1,x2;

 if (X<=0) return 0;
 x2=X;
 do {
   x1=x2;
   x2=x1-(x1*x1-X)/(2*x1);
  } while (fabs(x1-x2)>1E-4);
 return x2;

}


double zaokrouhli(double cis, int des_mist)
{

  int i;
  double cislo;

  cislo=cis;
  if (cis<0) cislo=-cislo;

  /* zaokrouhleni promenne na definovany pocet desetinnych mist */
  for (i = 0; i < des_mist; i++) cislo *= 10;
  cislo = (long)(cislo + 0.5);
  for (i = 0; i < des_mist; i++) cislo /= 10;

  if (cis<0) cislo=-cislo;
  return cislo;

}

double mxn(double x, int n)
{
 double y;

 y=x;
 while (n>1)
  {
   y=y*x;
   n--;
  }
 return y;
}

double msqrtn(double X, int n)
{
 double x1,x2,Q;

 if (n<2) return X;
 if ((X<=0)&&(n%2==0)) return 0;
 x2=X;
 do {
   x1=x2;
   Q=mxn(x1,n-1);
   x2=x1-(x1*Q-X)/(n*Q);
   Q=x1-x2;
   if (Q<0) Q=-Q;
  } while (Q>EPS);
 return x2;

}

void seterr(int x)
{
	errx=x;
}
